#/* $Header: /home/pat/TclTk/TkfPW-1.2pl1/lib/RCS/winlib.tcl,v 1.1 1997/10/27 20:26:23 pat Exp pat $ */
#/* $Author: pat $ */
#/* $Date: 1997/10/27 20:26:23 $ */
#/* $Log: winlib.tcl,v $
#/* Revision 1.1  1997/10/27 20:26:23  pat
#/* Initial revision
#/* */

proc WinLib {numlib} {

	global Obj_Lib Obj_Dir Obj_Mes
	global Obj_WinLib
	global Process Images

	set Obj_Mes(main-status) ""

	set lib $Obj_Lib($numlib)
	show-status "Opening Window Lib $lib ..." main-status

	# find a Window name based on the Lib number

	set wlib [WinLib_SetWinName $numlib]

	# Return (and eventually deiconify) if window exists

	if [winfo exists $wlib] {
		show-status "Window Lib $lib is Opened !" main-status
		wm deiconify $wlib
		return
	}

	toplevel $wlib
	wm title $wlib "$lib"
	wm iconbitmap $wlib @$Images(bitmap,winlib)
	wm protocol $wlib WM_DELETE_WINDOW { }

	# Update the list of already opened Win Lib.
	WinLib_UpdateListWinOpened

	# Main Frame Container
	# ====================

	set wf $wlib.f
	frame $wf

	# Button Window

	set wbut $wf.button
	frame $wbut -bd 2 -relief sunken

	button $wbut.close -text "Close" -cursor {pirate} -underline 0 \
		-command [list WinLib_close $numlib]
	button $wbut.iconify -text "Icon" -state normal  -underline 0 \
		-command [list wm iconify $wlib]
	pack $wbut.close $wbut.iconify -side left

	bind $wlib <Alt-c> "focus $wbut.close"
	bind $wlib <Alt-i> "focus $wbut.iconify"
	bind $wbut.close   <Return> "$wbut.close flash ; $wbut.close invoke"
	bind $wbut.iconify <Return> "$wbut.iconify flash ; $wbut.iconify invoke"

	pack $wbut -side bottom -pady 2m

	# Image Buttons Frame

	set wibut $wf.ibutton
	frame $wibut -bd 2 -relief sunken

	# Button Window for Xterm with a nice image !!!
	set wxterm $wibut.xterm
	frame $wxterm -bd 2 -relief sunken
	image create photo imgxterm -file $Images(gif,xterm)
	button $wxterm.but \
		-image imgxterm \
		-command [list WinLib_Xterm $numlib]
	pack $wxterm.but

	# Button Window for Listing with a nice image !!!
	set wlisting $wibut.list
	frame $wlisting -bd 2 -relief sunken
	image create photo imgindex -file $Images(gif,index)
	button $wlisting.but \
		-image imgindex \
		-command [list WinLib_ShowFiles $wlib $numlib]
	pack $wlisting.but

	# Button Window for Archive Modules with a nice image !!!
	set warmod $wibut.armod
	frame $warmod -bd 2 -relief sunken
	image create photo imgarmod -file $Images(gif,tools)
	button $warmod.but \
		-image imgarmod \
		-command [list WinLib_ShowArMembers $wlib $numlib]
	pack $warmod.but

	# Button Window for Infos with a nice image !!!
	set winfos $wibut.infos
	frame $winfos -bd 2 -relief sunken
	image create photo imginfo -file $Images(gif,info)
	button $winfos.but \
		-image imginfo \
		-command [list WinLib_GetSetUpInfo $wlib $numlib]
	pack $winfos.but

	pack $wxterm $wlisting $warmod $winfos -side left
	pack $wibut -side bottom -pady 2m

	# Label Windows For Info

	#"Static"
	set winfs $wf.infos
	frame $winfs

	label $winfs.title -text "Library $lib\nArchive [file tail $Obj_Lib($numlib,libar)]" \
		 -borderwidth 2 -relief ridge
	pack $winfs.title  -side top -pady 2m

	pack $winfs -side top -pady 2m

	#"Dynamic"
	set winfd1 $wf.infod1
	frame $winfd1 -bd 2 -relief ridge
	label $winfd1.name -text "Number of Fortran files :" -width 25 -anchor w
	label $winfd1.value -textvariable Obj_Lib($numlib,nb_regf) \
				-width 10 -relief ridge
	pack $winfd1.name -side left
	pack $winfd1.value -side left -expand true -fill x

	set winfd2 $wf.infod2
	frame $winfd2 -bd 2 -relief ridge
	label $winfd2.name -text "Number of Bugged files :" -width 25 -anchor w
	label $winfd2.value -textvariable Obj_Lib($numlib,nb_errcp) \
				-width 10 -relief ridge
	pack $winfd2.name -side left
	pack $winfd2.value -side left -expand true -fill x

	set winfd3 $wf.infod3
	frame $winfd3 -bd 2 -relief ridge
	label $winfd3.name -text "Files to be (Re-)Compiled :" -width 25 -anchor w
	label $winfd3.value -textvariable Obj_Lib($numlib,nb_recf) \
				-width 10 -relief ridge
	pack $winfd3.name -side left
	pack $winfd3.value -side left -expand true -fill x

	pack $winfd1 $winfd2 $winfd3 -side top -pady 1m


#NEW	# Scrolled Text for Checking Infos
	set wfrchk $wf.wfrchk
	frame $wfrchk -bd 2 -relief ridge
	set wfrchk_text $wfrchk.text
	set wtextchk [ ScrolledText $wfrchk_text -width 40 -height 8 \
			-wrap word -setgrid true -cursor {top_left_arrow}]
	pack $wfrchk -side top -fill both -expand true -padx 1m -pady 1m

	# Text Window for Bugged Files
	set wfrtext $wf.frame
	frame $wfrtext -bd 2 -relief ridge
	set wtext [ScrolledText $wfrtext -width 40 -height 8 \
			-wrap word -setgrid true -cursor {top_left_arrow}]

	# Create Buttons in Frame for Compilation set up

	set wcomp $wf.comp
	frame $wcomp -bd 2 -relief ridge

	# Buttons
	set wcompbut $wcomp.but
	frame $wcompbut -bd 2 -relief sunken
	button $wcompbut.selfiles -text "Select Files" \
		-state normal \
		-command [list WinLib_ListSelect $numlib]
	button $wcompbut.seloptions -text "Select Options" \
		-state normal \
		-command [list WinLib_SetCompileOptions $numlib]
	button $wcompbut.updatelib -text "Update" \
		-state normal \
		-command [list WinLib_updatelib $numlib]
	pack $wcompbut.selfiles $wcompbut.seloptions $wcompbut.updatelib -side left
	pack $wcompbut -side bottom -pady 2m -padx 4m	

	# Label for Static info.
	set wcompinf $wcomp.inf
	label $wcompinf -text "Compilation Set Up" \
		-width 30 -borderwidth 2 -relief raised
	pack $wcompinf -side bottom -padx 4m -pady 2m -expand yes

	pack $wcomp -side bottom -pady 2m

	# Create Window for Dynamic Status
	set wstat $wf.status
	label $wstat -textvariable Obj_Mes($wlib-status) \
		-width 30 -relief ridge
	pack $wstat -side bottom -pady 2m

	pack $wf -expand true -fill both

	center_window $wlib

	# Windows binding

	bind $wcompbut.selfiles   <Enter> [list ShowStatus "Select Files to compile" $wlib-status]
	bind $wcompbut.selfiles   <Leave> [list ShowStatus "Ready ..." $wlib-status]
	bind $wcompbut.seloptions <Enter> [list ShowStatus "Select compilation Options" $wlib-status]
	bind $wcompbut.seloptions <Leave> [list ShowStatus "Ready ..." $wlib-status]
	bind $wcompbut.updatelib  <Enter> [list ShowStatus "Update the Lib" $wlib-status]
	bind $wcompbut.updatelib  <Leave> [list ShowStatus "Ready ..." $wlib-status]
	bind $wxterm.but    <Enter> [list ShowStatus "Open an X Terminal Emulator in Lib" $wlib-status]
	bind $wxterm.but    <Leave> [list ShowStatus "Ready ..." $wlib-status]
	bind $wlisting.but  <Enter> [list ShowStatus "Show a List of Files" $wlib-status]
	bind $wlisting.but  <Leave> [list ShowStatus "Ready ..." $wlib-status]
	bind $warmod.but  <Enter> [list ShowStatus "Show/Modify Archive Members" $wlib-status]
	bind $warmod.but  <Leave> [list ShowStatus "Ready ..." $wlib-status]
	bind $winfos.but  <Enter> [list ShowStatus "Get/Set Up Infos on Library" $wlib-status]
	bind $winfos.but  <Leave> [list ShowStatus "Ready ..." $wlib-status]

	# Save some usefull names of widgets attached to the current lib window
	set Obj_WinLib($numlib,wlib) 		$wlib
	set Obj_WinLib($numlib,wmaster) 	$wf
	set Obj_WinLib($numlib,wfrtext) 	$wfrtext
	set Obj_WinLib($numlib,wtextchk) 	$wtextchk
	set Obj_WinLib($numlib,wtext) 		$wtext
	set Obj_WinLib($numlib,wbutself) 	$wcompbut.selfiles
	set Obj_WinLib($numlib,wbutselo) 	$wcompbut.seloptions
	set Obj_WinLib($numlib,wbutcomp) 	$wcompbut.updatelib
	set Obj_WinLib($numlib,wbutquit) 	$wbut.close
	set Obj_WinLib($numlib,wstatus) 	$wlib-status

	# Update the Checking Text Window
	WinLib_UpdateWinTextChk $numlib

	# Update the Text Window
	WinLib_UpdateWinText $numlib

	# Ready
	set Obj_Lib($numlib,list_recf_select) {}
	InitLibProcess $numlib ready

	show-status "Ready ..." $wlib-status

}
proc WinLib_UpdateWinTextChk {numlib} {
# Lib Text Window for Checking infos

	global Obj_Lib Obj_WinLib CheckLevel
	global BalloonHelp

	if ![info exists Obj_WinLib($numlib,wlib)] {return}
	if ![winfo exists $Obj_WinLib($numlib,wlib)] {return}

	set wlib	$Obj_WinLib($numlib,wlib)
	set wtextchk	$Obj_WinLib($numlib,wtextchk)

	# Refresh
	$wtextchk configure -state normal
 	$wtextchk delete 1.0 end


	# Tags
	if {[tk colormodel .] == "color"} {
	set title_tag	"-background green -borderwidth 2 -relief flat"
	set chapter_tag	"-background gold -borderwidth 1 -relief sunken"
	set error_tag	"-background wheat1 -borderwidth 2 -relief raised"
	} else {
	set title_tag	"-borderwidth 2 -relief flat"
	set chapter_tag	"-borderwidth 1 -relief sunken"
	set error_tag	"-borderwidth 2 -relief raised"
	}
	eval "$wtextchk tag configure title"	$title_tag
	eval "$wtextchk tag configure chapter" $chapter_tag
	eval "$wtextchk tag configure error" $error_tag

	$wtextchk insert end "Checking Info " title
	$wtextchk insert end "\n\n"

	# Fill in the Text Window
	$wtextchk insert end " Status " chapter
	foreach status $Obj_Lib($numlib,status) {
		if [string match "*Check Level*" $status] {
			$wtextchk insert end \n\n
			$wtextchk insert end $status error
		} else {
			foreach item $status {
				$wtextchk insert end "\n$item"
			}
		}
	}
	if { $Obj_Lib($numlib,status) == {} } {

		CheckLevelStatus lib
		if {$CheckLevel(lib,on)} {
			$wtextchk insert end "\nUp to Date"
		} else {
			$wtextchk insert end "\nChecking Disabled !" error
		}
	}

	$wtextchk see 1.0
	$wtextchk mark set insert 0.0
	$wtextchk configure -state disabled
	update idletasks

	# Bindings for Balloon Help
	bind $wtextchk <Enter> [list SetBalloonHelp $wtextchk \
	"Window status on library checking\n\
	See the Checking Window for details"]
	bind $wtextchk <Leave> [list UnsetBalloonHelp $wtextchk]

}
proc WinLib_GetSetUpInfo {parent numlib} {
	global Obj_WinLib Obj_Dir Obj_Lib

	# Set Up some paths and windows
	# =============================

	set lib 	$Obj_Lib($numlib)
	set libpath	$Obj_Dir(Lib)/$Obj_Lib($numlib)

	# Create the Window
	# =================

	set title "Infos on Library $lib"

	if ![winfo exists $parent] { set parent "" }
	set w $parent.infolib
	if [winfo exists $w] {
		wm deiconify $w
		return
	}
	toplevel $w
	wm title $w $title
    	wm transient $w [winfo toplevel [winfo parent $w]]
	wm protocol $w WM_DELETE_WINDOW { }

	# Main Frame Container
	# ====================

	set wf $w.f
	frame $wf

	# Create a Title
	# ==============

	set wtitle $wf.title
	label $wtitle -text $title \
	 -relief ridge -borderwidth 2
	pack $wtitle -side top -pady 5

	# Create a Scrollable Text Widget to log infos
	# ============================================

	set wtext $wf.t
	frame $wtext -bd 2 -relief ridge
	set wlog [ScrolledText $wtext -width 40 -height 15 \
			-wrap word -setgrid true]

	# Frame for Buttons
	# =================

	set wbut $wf.but
	frame $wbut -bd 2 -relief sunken

	button $wbut.close -text "Close" -state normal -cursor {pirate} \
		 -command [list destroy $w]
	button $wbut.save -text "Save" -state normal \
		 -command [list WinLib_GetSetUpInfo_save $libpath/README $wlog]
	pack $wbut.close $wbut.save -side left

	# Pack the Main Frames
	# ====================

	pack $wtext -side top -pady 5
	pack $wbut -side bottom -padx 1m -pady 1m
	pack $wf -expand true -fill both

	center_window $w

	# Insert the README file if present

	if [file exists $libpath/README] {
		$wlog delete 1.0 end
		$wlog insert end \
			[exec cat $libpath/README]
	} else {
		$wlog delete 1.0 end
		$wlog insert end "\tNo Infos yet available !\n"
	}
}
proc WinLib_GetSetUpInfo_save {file wlog} {
	set file_content [$wlog get 1.0 end]
	WriteVarInFile [$wlog get 1.0 end] $file
}

proc WinLib_UpdateListWinOpened {} {
	global Obj_Lib Obj_OpenedLibWin
	set iwopen 0
	for {set i 1} {$i <= $Obj_Lib(number)} {incr i} {

		set w [WinLib_SetWinName $i]
		if [winfo exists $w] {
			incr iwopen
			set  Obj_OpenedLibWin($iwopen,title) $Obj_Lib($i)
			set  Obj_OpenedLibWin($iwopen,window) $w
	 	}
	}
	set Obj_OpenedLibWin(number) $iwopen
PRINT "$Obj_OpenedLibWin(number) WinLib Opend"
	WinLib_MenuWinOpened update
}
proc WinLib_SetWinName {num} {
	set wlib .wlib_#$num
	return $wlib
}
proc WinLib_close {numlib} {
	global Obj_WinLib Obj_Lib

	# Get the Window lib name
	set wlib $Obj_WinLib($numlib,wlib)

	# Stop Traces on Lib
        trace vdelete Process(lib,compiling,$numlib) w TraceLibCompil
        trace vdelete Process(lib,selectopts,$numlib) w TraceLibSelCompOpt
        trace vdelete Process(lib,selectfiles,$numlib,status) w TraceLibListSelect
        trace vdelete Process(libar,selectfiles,$numlib,status) w TraceLibarListSelect

	# Set Up the Processees to "off"
	InitLibProcess $numlib off

	# Destroy the Window lib
	destroy $wlib

	# Update the list of Opened Window lib
	WinLib_UpdateListWinOpened
}
proc WinLib_Xterm {numlib} {
	global Obj_WinLib Obj_Lib Obj_Dir Process Glob_Pref

	set dir $Obj_Dir(Lib)/$Obj_Lib($numlib)

	set Xterm $Glob_Pref(Xterm)
	set XtermOpt_def $Glob_Pref(XtermOpt)
	set XtermOpt_imp {-T "TkfPW : Library $Obj_Lib($numlib)" -n "Lib $Obj_Lib($numlib)"}
	if [ catch { cd $dir ; eval exec $Xterm $XtermOpt_def $XtermOpt_imp & } XtermPid ] {
		tk_dialog .d$numlib {TkfPW Error} \
			"I Detected a problem on the X Window\
			Emulator :\n $XtermPid" error 0 {Ooops !}
	} else {
		# Ok, Xterm is running, register the process
		set trace_type lib
		set trace_id $numlib
		set Process($trace_type,xterm,$trace_id,status) running
		set Process($trace_type,xterm,$trace_id,pid) $XtermPid
	}
}
proc WinLib_updatelib {numlib} {
	global Obj_WinLib Obj_Lib Obj_Dir Process

	busy [list GetInfoLib $numlib]
#	GetInfoLib $numlib

	set wlib $Obj_WinLib($numlib,wlib)
	set pathfiles $Obj_Dir(Lib)/$Obj_Lib($numlib)

	# Setup the list of files to compile
	if { $Obj_Lib($numlib,list_recf_select) == {} } {
		#1 the user didn't picked a list of files
		if { $Obj_Lib($numlib,nb_recf) > 0 } {
			# Choose files that need (re-)compilation
			set list_files $Obj_Lib($numlib,list_recf)
		} else {
		#2 That's Fun, Nothing to do !
			set list_files {}
		}
	} else {
		#3 the user has picked a list of files
		set list_files $Obj_Lib($numlib,list_recf_select)
	}

	# Get the Absolute name
	set list_tmp {}
	foreach file $list_files { lappend list_tmp $pathfiles/$file }
	set list_files $list_tmp

	set trace_id $numlib
	set trace_type lib

	# Trace for the Compilation Procedure done
	trace variable Process($trace_type,compiling,$trace_id) w TraceLibCompil

	# Launch the Compilation Procedure
	set title "TkfPW Library Maintainer\nLib $Obj_Lib($numlib)"
	WinLib_MakeCompile $wlib $trace_type $trace_id $list_files $title
}
proc WinLib_SetCompileOptions {numlib} {
	global Obj_WinLib Obj_Lib Obj_Dir Process

	busy [list GetInfoLib $numlib]
#	GetInfoLib $numlib

	set wlib $Obj_WinLib($numlib,wlib)
	set lib $Obj_Lib($numlib)
	set title "Compiler Selection Option\nIn Lib $lib"
	set pathfiles $Obj_Dir(Lib)/$Obj_Lib($numlib)

	# Setup a list of files
	if { $Obj_Lib($numlib,list_recf_select) == {} } {
		# the user didn't picked a list of files
		if { $Obj_Lib($numlib,nb_recf) > 0 } {
		#1 Choose files that need (re-)compilation
			set list_files $Obj_Lib($numlib,list_recf)
		} else {
		#2 Choose all regular files
			set list_files $Obj_Lib($numlib,list_regf)
		}
	} else {
		#3 the user has picked a list of files
			set list_files $Obj_Lib($numlib,list_recf_select)
	}

	set trace_type lib
	set trace_id $numlib

	# Trace for Compiler Options Selection done
	trace variable Process($trace_type,selectopts,$trace_id) w TraceLibSelCompOpt

	# Launch the Compiler Options Selection Procedure
	SetCompileOptions $title $wlib \
			$trace_type $trace_id \
			$pathfiles $list_files
}

proc WinLib_ListSelect {numlib} {
#Choose the files to (re-)compile in lib
	global Obj_Lib Obj_Dir Obj_WinLib Process

	busy [list GetInfoLib $numlib]
#	GetInfoLib $numlib

	set lib $Obj_Lib($numlib)
	set wlib $Obj_WinLib($numlib,wlib)

	set trace_type lib
	set trace_id $numlib
	# Trace for Selection done
	trace variable Process($trace_type,selectfiles,$trace_id,status) w TraceLibListSelect

	set Obj_Lib($numlib,list_recf_select) {}
	# Launch the Selection
	ListSelect "File Selection In Lib $lib" $wlib \
			$trace_type $trace_id \
			$Obj_Lib($numlib,list_regf) "Choices" \
			$Obj_Lib($numlib,list_recf) "Picked"
}
proc WinLib_UpdateWinText {numlib} {
# Lib Text Window for Bugged Files with dynamic infos

	global Obj_Lib Obj_Dir Obj_WinLib Glob_Pref
	global BalloonHelp

	set wlib	$Obj_WinLib($numlib,wlib)
	set wmaster	$Obj_WinLib($numlib,wmaster)
	set wfrtext	$Obj_WinLib($numlib,wfrtext)
	set wtext	$Obj_WinLib($numlib,wtext)

	# Set up display styles for the bugged files tags

	if {[tk colormodel .] == "color"} {

	set errtag_on  "-background cyan -borderwidth 1"
	set errtag_off "-background {}"
	set errtag_err  "-foreground  red"
	eval "$wtext tag configure errortag" $errtag_err

	$wtext tag configure stylebutt -relief raised -borderwidth 1 -background green
	$wtext tag configure gotonext -relief raised -borderwidth 1 -background yellow
	$wtext tag configure gotoprev -relief raised -borderwidth 1 -background yellow

	} else {

	set errtag_on  "-background {} -borderwidth 1"
	set errtag_off "-background {}"
	set errtag_err  "-foreground {}"
	eval "$wtext tag configure errortag" $errtag_err

	$wtext tag configure stylebutt -relief raised -borderwidth 1
	$wtext tag configure gotonext -relief raised -borderwidth 1
	$wtext tag configure gotoprev -relief raised -borderwidth 1

	}

	# Refresh
	$wtext configure -state normal
 	$wtext delete 1.0 end

	# Fill in the Text Window
	set pathlib $Obj_Dir(Lib)/$Obj_Lib($numlib)

	set i 0

	set numerr [llength $Obj_Lib($numlib,list_errcp)]
	if { $numerr == 0 } {
	# If no Error files, mask the frame, then done
		pack forget $wfrtext
		return
	} else {
	# If Error files, show the frame
		pack $wfrtext -in $wmaster

	}

	foreach errfile $Obj_Lib($numlib,list_errcp) {

		# Obtain the $Glob_Pref(FortranExt) file name from the .errcp file name
		regsub "\.errcp$" $errfile .$Glob_Pref(FortranExt) file

		if { $i == 0 } {
			$wtext insert end "\nList of Bugged Files :\n\n"
			$wtext see end
		}

		# the tag of the file is the filename !
		# that's make things easier to manage...

		incr i ; set tagname $file
		InProgress $wtext $numerr "Browsing the Error Files\nin Lib $Obj_Lib($numlib)" $i

		# File name with Previous/Next tags
		$wtext insert end " < " gotoprev
		$wtext insert end "\t$i\t" stylebutt
		$wtext insert end " > " gotonext
		$wtext insert end \t
		$wtext insert end " $file " "stylebutt $tagname"
		$wtext insert end \n

		# Insert the Error file
		if [file exists $pathlib/$errfile] {		
			$wtext insert end \
				[exec cat $pathlib/$errfile] errortag
		} else {
			$wtext insert end "Error File doesn't exist !" errortag
		}
		$wtext insert end \n\n
		$wtext see end

		# Install the tags
		$wtext tag bind $tagname <Any-Enter> \
			"$wtext tag configure $tagname $errtag_on"
		$wtext tag bind $tagname <Any-Leave> \
			"$wtext tag configure $tagname $errtag_off"
		$wtext tag bind $tagname <ButtonPress> [list EditFileFromWtext %W $pathlib]
#		$wtext tag bind gotonext <ButtonPress> [list GotoNextTagInWtext %W gotonext]
		$wtext tag bind gotonext <ButtonPress> [list GotoCharInWtext %W { > } -forwards]
		$wtext tag bind gotoprev <ButtonPress> [list GotoCharInWtext %W { < } -backwards]
		update idletasks

	}

	$wtext mark set insert 0.0
	$wtext configure -state disabled
	$wtext see 0.0
	update idletasks

	# Bindings for Balloon Help
	bind $wtext <Enter> [list SetBalloonHelp $wtext \
	"Bugged Files with dynamic infos\n\
	If that window is visible you still have\n\
	some debugging works to do !.\n\
	You can edit the bugged files by\n\
	cliking on their name."]
	bind $wtext <Leave> [list UnsetBalloonHelp $wtext]

}
proc WinLib_MenuWinOpened {action} {
	global Obj_OpenedLibWin
	set w $Obj_OpenedLibWin(fmenu)

	set mb $w.mb
	set m  $mb.menu

	# create
	if [ string match create $action ] {

		catch {destroy $mb}

		menubutton $mb -text {Windows} -menu $m \
			-relief raised \
			-underline 0 -disabledforeground {}
		pack $mb -padx 5 -pady 5 -fill x
		menu $m -tearoff 0

		bind $mb  <Leave> {show-status "Ready..." lib-status }
#		bind $mb <Alt-w> "focus $m"
	}


	# update
	if [ string match update $action ] {
		$m delete 0 last
	}

	for {set i 1} {$i <= $Obj_OpenedLibWin(number)} {incr i} {
		$m add command -label $Obj_OpenedLibWin($i,title) \
			-command [list RaiseDeiconifyAndFocus $Obj_OpenedLibWin($i,window) $m]
	}

	if { $Obj_OpenedLibWin(number) > 0 } {
		$mb configure -cursor sb_down_arrow -state normal
		bind $mb  <Enter> \
			{show-status "Activate an Opened library" lib-status }
	} else {
		$mb configure -cursor sb_up_arrow -state disabled
		bind $mb  <Enter> \
			{show-status "No Library Opened !" lib-status }
	}


}
proc WinLib_MakeCompile {parent trace_type trace_id list_files title} {
# Launch the Compilation
	global Glob_Pref

        # Create a toplevel window
	if ![winfo exists $parent] { set parent "" }
	set w $parent.gocomp

	if [winfo exists $w] {
		wm deiconify $w
		return
	}

	toplevel $w
	wm title $w $title
    	wm transient $w [winfo toplevel [winfo parent $w]]
	wm protocol $w WM_DELETE_WINDOW { }

	set wf $w.f
	frame $wf

	#################### Create a Frame for Title
	set wi $wf.info
	frame $wi

	label $wi.title -text $title \
		-borderwidth 2 -relief ridge
	pack $wi.title -side top
	pack $wi -side top -fill both

	#################### Create a Scrollable Text Widget to log the output
	set wst $wf.t 
	frame $wst -bd 2 -relief ridge
	set log [ScrolledText $wst -width 40 -height 8 \
			-wrap word -borderwidth 2 -setgrid true]

	#################### Create a Frame for Buttons
	set wbut $wf.but
	frame $wbut -bd 2 -relief ridge
	button $wbut.cancel -text "Cancel" -state normal \
		-command [list destroy $w]
	button $wbut.action -text "GO" -state normal \
		-command "[list RunCompile $trace_type $trace_id $w $list_files $log $wbut.action];
			  $wbut.cancel config -state disabled"
	pack $wbut.action $wbut.cancel -side left

	#################### (re-)Pack the Main frames
	pack $wi -side top -fill both -padx 2m -pady 2m
	pack $wst -side top -expand true -fill both -padx 2m -pady 2m
	pack $wbut -side bottom -pady 2m -padx 4m

	pack $wf -expand true -fill both

	#################### Set Up somes tags for the Text Widget
	SetWlogTargs $log

	$log insert end "Press the GO button to start ...\n" READY

	center_window $w

}
proc WinLib_ShowArMembers {parent numlib} {
# Show list of Archive Members
	global Obj_Lib Obj_Dir
	global Obj_WinLib Process

	set lib $Obj_Lib($numlib)
	if ![file exists $Obj_Lib($numlib,libar)] {
		tk_dialog $parent.ar#$numlib {TkfPW Warning} \
			"Archive [file tail $Obj_Lib($numlib,libar)]\nDoesn't Exist !" \
			error 0 {Ok ?}
		return
	}

	if [catch {open "|ar tv $Obj_Lib($numlib,libar)" r} id($lib)] {
		tk_dialog $parent.ar#$numlib {TkfPW Warning} \
			"Can't get Infos on\nArchive [file tail $Obj_Lib($numlib,libar)]\nReason : $id($lib)" \
			error 0 {Hum...}
		return
	}

	set list_modules {}
	while {1} {
		gets $id($lib) line
		if [eof $id($lib)] {break}
		lappend list_modules $line
	}
	close $id($lib)

	set trace_type libar
	set trace_id $numlib

	# Trace for Selection done
	trace variable Process($trace_type,selectfiles,$trace_id,status) w TraceLibarListSelect
	
	# Launch Selection
	ListSelect 	"Archive Members of Library\n$lib" \
			$parent \
			$trace_type $trace_id \
			$list_modules 	"Active Members" \
			{} 		"Members to Delete"

}
proc WinLib_DeleteArMembers {numlib} {
# Delete Selected Members in Archive
global Process Obj_WinLib Obj_Lib
	set wlib		$Obj_WinLib($numlib,wlib)
	set libar		$Obj_Lib($numlib,libar)
	set ListInfoModule	$Process(libar,selectfiles,$numlib,value)
	set number [llength $ListInfoModule]
	set i 0
	foreach info_module $ListInfoModule {
		set module [ lindex $info_module [expr [llength $info_module] -1] ]
		if [ catch {eval exec ar d $libar $module} err ] {
			PRINT "*** TkfPW WARNING : Can't Delete Member $module in Archive $libar !"
			PRINT "*** TkfPW WARNING : $err"
		} else {
			incr i
			InProgress $wlib $number \
				"Deleting Members In Archive [file tail $libar]" $i
		}
	}

	if { $i == $number } {
		tk_dialog $wlib.ar#$numlib {TkfPW Infos} \
			"Selected Members have\nbeen deleted from\nArchive [file tail $libar]" \
			info 0 {Ok}
	}
}
proc WinLib_ShowFiles {parent numlib} {
# Show list of files
	global Obj_Lib Obj_Dir
	global Obj_WinLib

        # Create a toplevel window
	if ![winfo exists $parent] { set parent "" }
	set w $parent.showfiles

	if [winfo exists $w] {
		wm deiconify $w
		return
	}

	set lib $Obj_Lib($numlib)
	set title "Library $lib"

	toplevel $w
	wm title $w $title
    	wm transient $w [winfo toplevel [winfo parent $w]]
	wm protocol $w WM_DELETE_WINDOW { }

	# Main Frame Container
	# ====================

	set wf $w.f
	frame $wf

	# Create a Label for info
	# =======================

	label $wf.title -text $title \
		-borderwidth 2 -relief sunken
	pack $wf.title -side top -pady 5m

	# Create a Frame for Files Listing
	# ================================

	set wsel $wf.sel
	frame $wsel -bd 5 -relief ridge
		# Create a Scrollable Canvas for the Selection of Targets
		set wcanvas [ScrolledCanvas $wsel.cvs \
				-width 20 -height 20 ]
		# Create one frame to hold everything for the selection
		# and position it on the canvas
		set wlistfiles [frame $wcanvas.wlistfiles]
		$wcanvas create window 0 0 -anchor nw -window $wlistfiles

	# Create General Buttons
	# ======================

	set wbut $wf.buttons
	frame $wbut -bd 2 -relief sunken
	button $wbut.close -text "Close" -state normal -cursor {pirate} \
		-command [list destroy $w]

	pack $wbut.close -side top

	# Pack the Main Frames
	# ====================

	pack $wsel -side top -fill y -expand true
	pack $wbut -side bottom
	pack $wf -expand true -fill both

	# Save some usefull names of widgets attached to the current window
	# =================================================================

	set Obj_WinLib($numlib,wlistfiles) 	$wlistfiles
	set Obj_WinLib($numlib,wcanvas) 	$wcanvas

	# Create and pack the widgets defining the Target selection
	# =========================================================

	WinLib_ShowFiles_update $numlib
}
proc WinLib_ShowFiles_update {numlib} {
# Create/Update the widgets defining the file listing in lib

	global Obj_Lib Obj_Dir
	global Obj_WinLib
	global Images Glob_Pref
	global Stream_EditFile

	# Return if container doesn't exists
	# ==================================

	if ![info exists Obj_WinLib($numlib,wlistfiles)] {return}
	if ![winfo exists $Obj_WinLib($numlib,wlistfiles)] {return}

	# Set Up some paths and windows
	# =============================

	set lib 	$Obj_Lib($numlib)
	set libpath	$Obj_Dir(Lib)/$Obj_Lib($numlib)

	set wlistfiles	$Obj_WinLib($numlib,wlistfiles)
	set wcanvas	$Obj_WinLib($numlib,wcanvas)

	image create photo imgf77 -file $Images(gif,f77_file)
	image create photo imglnk -file $Images(gif,f77_linkfile)
	image create photo imgerr -file $Images(gif,broken_file)
	image create photo imgnew -file $Images(gif,alert_file)

	# Update/Create and pack the widgets
	# ==================================

	if ![ catch {pack slaves $wlistfiles} list_slaves ] {
		foreach slave $list_slaves {
			catch {destroy $slave}
		}
	}
	
	set i 0
	foreach file $Obj_Lib($numlib,list_regf) {
		incr i
		pack [frame $wlistfiles.$i] -side top -expand y -fill both

		button	$wlistfiles.$i.button -command [list EditFileNew $wlistfiles $libpath/$file $wlistfiles.$i.button]
			if [ ItemIsInList $file $Obj_Lib($numlib,list_recf) ] {
				regsub "\.$Glob_Pref(FortranExt)$" $file {.errcp} file_errcp

				if [ ItemIsInList $file_errcp $Obj_Lib($numlib,list_errcp) ] {
				$wlistfiles.$i.button configure -image imgerr
				} else {
				$wlistfiles.$i.button configure -image imgnew
				}
			} else {
				if { [file type $libpath/$file] == "link" } {
					$wlistfiles.$i.button configure -image imglnk
				} else {
					$wlistfiles.$i.button configure -image imgf77
				}
			}
		label	$wlistfiles.$i.file -width 20 -text $file -justify left -relief ridge
		label	$wlistfiles.$i.status -text [clock format [file mtime $libpath/$file] \
				-format "%D %T"] -justify left -relief ridge

		pack $wlistfiles.$i.button $wlistfiles.$i.file $wlistfiles.$i.status \
				-side left -anchor w
		if [info exists Stream_EditFile($libpath/$file)] \
			{$wlistfiles.$i.button configure -state disabled}
	}

	# Update the ScrollBar of the Canvas
	# ==================================

	# Wait for the window to become visible and then
	# set up the scroll region and increment based on
	# the size of the frame and the subframes

	set child0 [lindex [pack slaves $wlistfiles] 0]
#???	if ![winfo exists $child0] {return}
	tkwait visibility $child0

 	set incr [winfo height $child0]
	set width [winfo width $wlistfiles]
	set height [winfo height $wlistfiles]
	$wcanvas config -scrollregion "0 0 $width $height"
	$wcanvas config -yscrollincrement $incr
	if {$height > 4 * $incr} {
		set height [expr 4 * $incr]
	}
	$wcanvas config -width $width -height $height
}

proc CreateNewLib {wlib wlib_list} {
# Create a new Library
	global Obj_Lib Obj_Dir Obj_OpenedProjWin Obj_OpenedLibWin Glob_Pref

	if { $Obj_OpenedProjWin(number) > 0 || $Obj_OpenedLibWin(number) > 0 } {
		tk_dialog $wlib.d {TkfPW Warning} "Before creating a new Lib\nYou need to close ALL\nProject & Lib Windows" error 0 {Ok !}
		return
	}

	while {1} {
		set lib [GetValue $wlib {Enter Name for New Library}]
		if { $lib == {} } {
			break
		} else {
			if [ ItemIsInList $lib $Obj_Lib(list)] {
				tk_dialog $wlib.d {TkfPW Warning} "$lib Already Defined !" error 0 {Ooops !}
			} else {
				break
			}
		}
	}

	if { $lib != {} } {
		if [catch {makedir $Obj_Dir(Lib)/$lib} err] {
			tk_dialog $wlib.d {TkfPW Error} "Cannot create Library\n$lib\nReason:\n$err" error 0 {Ok ?}
			return
		} else {
			# create a kill_me.$Glob_Pref(FortranExt) file (i need a $Glob_Pref(FortranExt) existing file !)
			if [catch {open $Obj_Dir(Lib)/$lib/kill_me.$Glob_Pref(FortranExt) w} fileId] {
				close $fileId
			}
			tk_dialog $wlib.d {TkfPW Info} "Creating Library\n$lib\nDone:\nReady to Update" info 0 {Update}
			ScanForLib $wlib $wlib_list
		}
	}		
	
}

proc ResetAllLib {wlib wlib_list} {
# Reset the libraries
	global Obj_Dir Obj_OpenedProjWin Obj_OpenedLibWin

	if { $Obj_OpenedProjWin(number) > 0 || $Obj_OpenedLibWin(number) > 0 } {
		tk_dialog $wlib.d {TkfPW Warning} "To Reset Libraries,\nYou need to close ALL\nProject & Lib Windows" error 0 {I Will !}
		return
	} else {
		busy [list ScanForLib $wlib $wlib_list]
	}
	
}
